import { demoConfig2 } from "./demo-config";
import "@vanillawc/wc-codemirror";

import "./script-graph";
// import "./script-graph3";
import "./hat-graph/hat-graph-node";
import "./hat-graph/hat-graph";
import { makeGraph } from "./hat-graph/make-graph";

import { ActionHandler } from "./script-to-graph";

import { mdiAsterisk, mdiArrowUp, mdiArrowDown } from "@mdi/js";

let index_counter = 0;
let nodes = [];

window.onload = () => {
  return;
  //const graph2 = document.createElement("script-graph3");
  //document.querySelector("#graph2").appendChild(graph2);

  let src = demoConfig;

  const fullcode = document.querySelector("#fullcode");
  fullcode.mode = "yaml";
  window.setTimeout(() => (fullcode.value = jsyaml.safeDump(src)), 100);

  const updateButton = document.querySelector("#updateButton");
  updateButton.addEventListener("click", () => {
    src = jsyaml.safeLoad(fullcode.value);
    index_counter = 0;
    nodes = [];
    tr.actions = src;
    graph.tree = tr.graph;
  });

  const graph = document.createElement("script-graph");
  const tr = new ActionHandler();
  window.tr = tr;
  tr.actions = src;
  tr.updateCallback = (actions) => {
    graph.tree = tr.graph;
    fullcode.value = jsyaml.safeDump(tr.actions);
  };
  tr.selectCallback = (idx, action, update) => {
    graph.tree = tr.graph;
    const code = document.querySelector("#snippet");
    code.value = jsyaml.safeDump(action);
    document.querySelector("#saveSnippet").onclick = () =>
      update(jsyaml.safeLoad(code.value));
    document.querySelector("#deleteSnippet").onclick = () =>
      update(jsyaml.safeLoad(null));
  };

  graph.tree = tr.graph;
  document.querySelector("#graph").appendChild(graph);
};

function nodeSelected(ev) {
  const code = document.querySelector("#snippet");
  code.value = jsyaml.safeDump(ev.detail.config);
  code.currentNode = ev.target;
}

function rebuildGraph(config) {
  const graphCard = document.querySelector("#graph");

  while (graphCard.firstChild) graphCard.removeChild(graphCard.firstChild);

  const graph = makeGraph(config);
  graph.addEventListener("node-selected", nodeSelected);
  graph.addEventListener("update-node", (ev) => {
    const code = document.querySelector("#fullcode");
    code.value = jsyaml.safeDump(ev.detail.config);
    window.setTimeout(() => rebuildGraph(ev.detail.config), 100);
  });

  graphCard.appendChild(graph);
}

function setup_snippet_editor() {
  document.querySelector("#saveSnippet").onclick = () => {
    const code = document.querySelector("#snippet");
    if (code.currentNode) {
      code.currentNode.updateNode(jsyaml.safeLoad(code.value));
    }
  };
  document.querySelector("#deleteSnippet").onclick = () => {
    const code = document.querySelector("#snippet");
    if (code.currentNode) {
      code.currentNode.deleteNode();
    }
  };
}

function setup() {
  setup_snippet_editor();

  let src = demoConfig2;
  const fullcode = document.querySelector("#fullcode");
  fullcode.mode = "yaml";
  window.setTimeout(() => (fullcode.value = jsyaml.safeDump(src)), 100);

  rebuildGraph(src);

  const updateButton = document.querySelector("#updateButton");
  updateButton.addEventListener("click", () => {
    src = jsyaml.safeLoad(fullcode.value);
    rebuildGraph(src);
  });
}

setup();
